namespace View_by_Distance.Shared.Models.Properties;

public interface IMappingFromItem
{

    public int Id { init; get; }
    public FileHolder ImageFileHolder { init; get; }
    public bool? IsWrongYear { init; get; }
    public DateTime MinimumDateTime { init; get; }
    public string RelativePath { init; get; }
    public FileHolder ResizedFileHolder { init; get; }

}

public interface IMappingFromLocation
{

    public double AreaPermille { init; get; }
    public double Confidence { init; get; }
    public string DeterministicHashCodeKey { init; get; }
    public int NormalizedPixelPercentage { init; get; }

}

public interface IMappingFromPerson
{

    public int? ApproximateYears { init; get; }
    public string DisplayDirectoryName { init; get; }
    public PersonBirthday PersonBirthday { init; get; }
    public string SegmentB { init; get; }

}

public interface IMapping
{

    public int? By { get; }
    public MappingFromItem MappingFromItem { init; get; }
    public MappingFromLocation MappingFromLocation { init; get; }
    public MappingFromPerson? MappingFromPerson { get; }
    public SortingContainer? SortingContainer { get; }

}